//+------------------------------------------------------------------+
//|                                          Duablo_28.09.10_v01.mq4 |
//    http://codebase.mql4.com/ru/6231#comments "Jon Katana"
//+------------------------------------------------------------------+

double Up=0;
double Down=0;
extern int Levels=10;
int Step=0;
extern double Vol=0.1;
extern int Spread=20;

extern int    _PeriodATR =14;  // ATR     
extern double _KoefATR   =0.2; //     
int           _PrevDateO =0;
int           _PrevDateC =0;
extern int    Profit     =5; //      
extern int    Slippage   =5;   // 
double Pred_AccountEquity, _AccountEquity;
int i, z;

int start()
{
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
  if (_PrevDateO!=TimeDayOfYear(Time[0]) && OrdersTotal()==0)
  {
    Pred_AccountEquity=AccountEquity();
    _PrevDateO=TimeDayOfYear(Time[0]);
    Up=NormalizeDouble((Bid+(iATR(NULL,0,_PeriodATR,0)*_KoefATR)/2),4);
    Down=NormalizeDouble((Ask-(iATR(NULL,0,_PeriodATR,0)*_KoefATR)/2),4);
    Step=iATR(NULL,0,_PeriodATR,1)*_KoefATR/Point;
    for(i=0; i<(Levels-1); i++)
    {
      OrderSend(Symbol(),OP_BUYSTOP,Vol,NormalizeDouble(Up+(2*i*Step+Spread)*Point,4),0,0,0,0);
      OrderSend(Symbol(),OP_SELLSTOP,Vol,NormalizeDouble(Down-2*i*Step*Point,4),0,0,0,0,0);
      OrderSend(Symbol(),OP_SELLLIMIT,Vol,NormalizeDouble(Up+(2*i+1)*Step*Point,4),0,0,0,0,0);
      OrderSend(Symbol(),OP_BUYLIMIT,Vol,NormalizeDouble(Down-((2*i+1)*Step-Spread)*Point,4),0,0,0,0,0);
      OrderSend(Symbol(),OP_BUYSTOP,Vol,Up+(2*i*Step+Spread)*Point,0,Up+(2*i-1)*Step*Point,Up+(2*i+2)*Step*Point,0,0);
      OrderSend(Symbol(),OP_SELLLIMIT,Vol,Up+2*i*Step*Point,0,Up+((2*i+1)*Step+Spread)*Point,Up+(2*Step*(i-1)+Spread)*Point,0,0);
      OrderSend(Symbol(),OP_SELLSTOP,Vol,Down-2*i*Step*Point,0,Down-((2*i-1)*Step-Spread)*Point,Down-((2*i+2)*Step+Spread)*Point,0,0);
      OrderSend(Symbol(),OP_BUYLIMIT,Vol,Down-(2*i*Step-Spread)*Point,0,Down-(2*i+1)*Step*Point,Down-2*Step*(i-1)*Point,0,0);
    }
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
  _AccountEquity=AccountEquity();
  if (_AccountEquity-Pred_AccountEquity>Profit || _PrevDateC!=TimeDayOfYear(Time[0]))
  {
    _PrevDateC=TimeDayOfYear(Time[0]);
    for (z=OrdersTotal()-1; z>=0; z --)
    {
      OrderSelect (z, SELECT_BY_POS);
      if (OrderSymbol()!=Symbol()) continue;
      if ((OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) && TimeDayOfYear(Time[0])!=TimeDayOfYear(OrderOpenTime()))
      {OrderDelete(OrderTicket()); continue;}
      if ((OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT) && TimeDayOfYear(Time[0])!=TimeDayOfYear(OrderOpenTime()))
      {OrderDelete(OrderTicket()); continue;}
      if (OrderType()==OP_BUY && TimeDayOfYear(Time[0])!=TimeDayOfYear(OrderOpenTime())) //
      {OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue); continue;}
      if (OrderType()==OP_SELL && TimeDayOfYear(Time[0])!=TimeDayOfYear(OrderOpenTime())) //
      {OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);}
      continue;
    }
  }
  return(0);
}

